const Main = imports.ui.main;
const Tweener = imports.ui.tweener;
const Lang = imports.lang;
const ModalDialog = imports.ui.modalDialog;
const OPEN_AND_CLOSE_TIME = 0.1;
const State = {
    OPENED: 0,
    CLOSED: 1,
    OPENING: 2,
    CLOSING: 3,
    FADED_OUT: 4
};

let origFadeOpen;

function myFadeOpen() {
    let monitor = Main.layoutManager.primaryMonitor;
    this._backgroundBin.set_position(monitor.x, monitor.y);
    this._backgroundBin.set_size(monitor.width, monitor.height);
    this.state = State.OPENING;
    this._dialogLayout.opacity = 255;
    if (this._lightbox)
        this._lightbox.show();
    this._group.opacity = 0;
    this._group.show();
    Tweener.addTween(this._group,
                     { opacity: 255,
                       time: OPEN_AND_CLOSE_TIME,
                       transition: 'easeOutQuad',
                       onComplete: Lang.bind(this,
                           function() {
                               this.state = State.OPENED;
                               this.emit('opened');
                           })
                     });
}

function init() {
    origFadeOpen = ModalDialog.ModalDialog.prototype._fadeOpen;
}

function enable() {
    ModalDialog.ModalDialog.prototype._fadeOpen = myFadeOpen;
}

function disable() {
    ModalDialog.ModalDialog.prototype._fadeOpen = origFadeOpen;
}
